// Copyright 2013 Spotkick
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// Save this script as `options.js`

// Saves options to localStorage.
function save_options() {
  var select = document.getElementById("color");
  var color = select.children[select.selectedIndex].value;
  localStorage["favorite_color"] = color;

  // Update status to let user know options were saved.
  var status = document.getElementById("status");
  status.innerHTML = "Options Saved.";
  setTimeout(function() {
    status.innerHTML = "";
  }, 750);
}

// Restores select box state to saved value from localStorage.
function restore_options() {
  var favorite = localStorage["favorite_color"];
  if (!favorite) {
    return;
  }
  var select = document.getElementById("color");
  for (var i = 0; i < select.children.length; i++) {
    var child = select.children[i];
    if (child.value == favorite) {
      child.selected = "true";
      break;
    }
  }
}

// Fetch the inputs in AJAX, then send off to our background page to load/prep
function fetchInputsInBackground(the_url)
{
	console.log(' [*] Loading page ' + the_url);
	$.ajax({
		type: 'GET',
		url: the_url,
		async: false,
		success: function (response, textStatus, jqXHR){
			console.log( response );
			inputs = $('input', response);
		    chrome.extension.sendMessage( {type: "gen_parms", data: inputs}, function(response) {
				console.log( response.parms );
		    } );	
		}
	});
}

function run_spotkick(){
	chrome.tabs.query({'active': true}, function (tabs) {
		// Create a list of parameters and values that we will cycle through based
		// on the user's options.  Then, worker tabs pull the parameters off the
		// stack.
		fetchInputsInBackground( tabs[0].url );
		chrome.tabs.create({url: tabs[0].url})
	});
}

document.addEventListener('DOMContentLoaded', restore_options);
document.querySelector('#run').addEventListener('click', run_spotkick);
