// Copyright 2013 Spotkick
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Override javascript alert to catch XSS calls
var s = document.createElement("script");
s.src = chrome.extension.getURL("alerts.js");
(document.head||document.documentElement).appendChild(s);

runTask = function()
{
	console.log(" [*] Running task on page...");

	// Process the page + get next job (if any)
	msgProcessPage();
}

document.addEventListener("mousedown", function(event){
	console.log( " [*] Click! => ");
	console.log( event );
	msgNotifyClick( event.target );
}, true);

// Our manifest loads these on document_idle, so this theoretically is getting called after
// the ready event has fired.  Jquery indicates that the result is this just executes the ready()
// function immediately.
var harvest_timer = 0;
$(document).ready(function() {
	var harvest_ms = 5000;  // 5 seconds
	var state;
	
	// Process the page
	if ( harvest_timer != 0 )
	{
		console.log(' [*] Clearing Timer');
		clearInterval( harvest_timer );
	}	

	// Wait to process page
	harvest_timer = setTimeout( function(){
		runTask();
	}, harvest_ms ); 
});
